/* Смартвес ЭТА-01
 * ver 1.0.1
 * (c) Copyright 2023, GLONASSsoft
 * This file is provided as is (no warranties).
 */
 
 /* Получение данных */
static LibraETA01ReadBuff(Buff[], Size = sizeof(Buff), SerialPort:port = SERIAL_PORT_0)
{
  new Len, Offs = 0;
  new pBuff = 0;
  new BuffRead[12 * 3];
  
  Len = rsrecv(BuffRead, _, 300, 300, port);  // Читаем буфер
  for (new i = 0; i < Len; i++)
  {
    if (BuffRead[i] == 0x02)
    {
      Offs = i;
      break;
    }
  }
  while ((pBuff < Size) && (Offs < Len))
  {
    Buff[pBuff++] = BuffRead[Offs++];
    if (BuffRead[Offs] == 0x02) break;
  }
  printf("Data len=%d", pBuff);
  return pBuff    
}

/* Распарсивание данных */
static bool:LibraETA01Parse(DataBuff[], DataLen, &Weight, &WeightPow)
{
  new Value = 0;
  new bool:Negative = false;
  new crc = 0;

  if (DataLen != 12) return false;
    
  /* Проверка CRC */
  for (new i = 1; i < 9; i++) crc ^= DataBuff[i];
  new hcrc = ((crc & 0xF0) >> 4) + '0';
  new lcrc = crc & 0x0F;
  if (lcrc > 9) lcrc = 0x40 + lcrc - 9;
  else lcrc += '0';
  if (!(DataBuff[9] == hcrc && DataBuff[10] == lcrc)) return false;
    
  /* Знак */
  switch (DataBuff[1])
  {
    case '-': Negative = true;
    case '+': Negative = false;
    default: return false
  }
  
  /* Точка */
  WeightPow = DataBuff[8] - '0';
  
  /* Значение веса */
  for(new i = 2; i < 8; i++)
  {
    if ('0' <= DataBuff[i] <= '9')
    {
      Value *= 10;
      Value += DataBuff[i] - '0';
    }
    else return false
  }
  
  if (Negative) Value = -Value;
  Weight = Value;
  return true;
}

/* Получение веса */
stock bool:LibraETA01Read(SerialPort:port = SERIAL_PORT_0, &Weight, &WeightPow)
{
  new bool:Valid = false
  new Buff[32];
  new Len;
  
  Len = LibraETA01ReadBuff(Buff, _, port);
  printf("ETA01 read len=%d", Len);
  if (Len) 
  {
    Valid = LibraETA01Parse(Buff, Len, Weight, WeightPow);
    printf("ETA01 Valid=%d,Weight = %d,Pow=%d", Valid, Weight, WeightPow);
  }
  return Valid;
}