/* Script ETA_01.p
 * ver 1.0.2
 * (c) Copyright 2023, GLONASSsoft
 * This file is provided as is (no warranties).
 *
 * Чтение данных весов ЭТА-01
 * Период обновления данных 1000 мсек
 * Весы сами передают данные.
 *
 * Вес пишется в параметр скрипта. Номер параметра определен TAG
 */

#include <time>
#include <string>
#include <tracker>
#include <serial>

#include ETA_01

#define PERIOD        1000
#define LIBRA_PORT    SERIAL_PORT_0
#define TAG           0

#pragma dynamic 256

static ClearRxBuffer()
{
  new sb[32];   
  while (rsrecv(sb) != 0){}
}

main()
{  
  settimer(PERIOD);
}

@timer()
{
  new Weight = 0;
  new Pow = 0;
  new bool:Valid = false;
  
  printf("Loop");
  /* Читаем показания весов */
  if (rsopen(_, LIBRA_PORT) == true)  // Удалось открыть порт
  {
    ClearRxBuffer();  // Очищаем входной буфер
    Valid = LibraETA01Read(LIBRA_PORT, Weight, Pow);
    rsclose(LIBRA_PORT);
  }
  settag(TAG, Weight, Valid, Pow);  // Пишем вес в таг
}