#include <time>
#include <args>
#include tracker
#include serial
#include LibKv007Kp

#pragma dynamic 128

#define PERIOD_READ     1000 /* Периодичность чтения весов */

static ClearRxBuffer()
{
  new sb[32];

  while (rsrecv(sb) != 0){}
}

main()
{
  // NOTE: default behavior: REQUEST
  new IsPeriodic = 0;

  argvalue(0, "periodic", IsPeriodic);

  // Request type data 
  new WeightGross;
  new WeightNet;
  new PowGross;
  new PowNet;
  new bool:ValidGross;
  new bool:ValidNet;

  // Periodic type data 
  new PeriodicWeight = 0;
  new PeriodicPow = 0;
  new bool:ValidPeriodic;
  new PeriodicDataBuff[12];
  new PeriodicDataLen = 0;

  for (;;)
  {
    if (IsPeriodic)
    {
      ValidPeriodic = false;
    }
    else
    {
      ValidGross = false; 
      ValidNet = false;
    }

    if (rsopen() == true)
    {
      ClearRxBuffer();
      if (IsPeriodic)
      {
        PeriodicDataLen = ReadPeriodic(_, PeriodicDataBuff, sizeof(PeriodicDataBuff));
        ValidPeriodic   = ParsePeriodic(PeriodicDataBuff, PeriodicDataLen, PeriodicWeight, PeriodicPow);
      }
      else
      {
        ValidGross = ReadAnswer(_, WEIGHT_GROSS, WeightGross, PowGross);
        ValidNet   = ReadAnswer(_, WEIGHT_NET,   WeightNet,   PowNet); 
      }
      rsclose();
    }
    if (IsPeriodic)
    {
      settag(0, PeriodicWeight, ValidPeriodic, PeriodicPow);
    }
    else
    {
#if 1 
      /* Поступило обращение от клиента:
       * Добрый день. Прошу внести корректировку в протокол. 
       * Значения показателей меньше в 10 раз. Т.е. при весе 1220 кг показывает 122 кг.
       * Заранее спасибо. 
       * Так как в протокле и реализации несоответствия обнаружить не удалось, то просто домножаем на 10
       */
      WeightNet   *= 10
      WeightGross *= 10
#endif      
      settag(0, WeightNet,   ValidNet,   PowNet);   /* Пишем вес в таг */
      settag(1, WeightGross, ValidGross, PowGross); /* Пишем вес в таг */
    }

    delay(PERIOD_READ);
  }
}