/* 
 * Script LibrNvt6.p
 * ver 1.0 with
 * (c) Copyright 2022, GLONASSsoft
 * This file is provided as is (no warranties).
 *
 * Скрипт предназначен для работы с весовым индикатором НВТ-9
 * Данные из индикатора передаются в непрерывном режиме в коде ASCII в COM-порт ПЭВМ 
 * Настройки порта 9600 8-N-1
 */
#include <time>
#include <string>
#include tracker
#include serial
#include LibraNvt9

#pragma dynamic               256

#define SERIAL_PORT_LIBRA     SERIAL_PORT_0
#define WEIGHT_TAG            0

/* Скрипт */
main()
{
  new bool: Valid = false
  new Weight
  new WeightPow

  for(;;)
  {
    /* Читаем весы */
    Valid = false
    if (rsopen(SB_AUTO, SERIAL_PORT_LIBRA) == true) /* Удалось открыть порт */
    {
      new Buff[NVT9_RECV_LEN + 1]
      new Len
      
      Len = LibraNvt9Read(SERIAL_PORT_LIBRA, Buff, sizeof(Buff))
      Valid = LibraNvt9Parse(Buff, Len, Weight, WeightPow)
      printf("Len = %d Valid = %d", Len, Valid)
      rsclose(SERIAL_PORT_LIBRA) /* Освобождаем порт  */
    }
    settag(WEIGHT_TAG, Weight, Valid, WeightPow) /* Пишем вес в тег */
    delay(1000) /* пауза */
  }
}
