/* УСТРОЙСТВО ВЕСОИЗМЕРИТЕЛЬНОЕ ТИПА ВТ-008 (Найс)
 * (c) Copyright 2021, GLONASSsoft
 * This file is provided as is (no warranties).
 */

#pragma library LibraBT008

#include serial
#include string
#include float

stock Float:Hex2Float(hex_value)
{
    new string{64};  
    
    strformat(string, sizeof(string), false, "%f", hex_value);    
    return strfloat(string);    
}

/* Функция чтения данных о весе с весов */
stock bool:LibraBT008Read(SerialPort:port = SERIAL_PORT_0, &Weight, &Pow)
{
    new Buff[16]
    
    new Len
    new Float:Value;
    new v;

    Buff[0] = 'W' /* символ синхронизации  */
    Buff[1] = '0' /* номер терминала */
    Buff[2] = 'G' /* команда  G – считывание показаний весов */
    Buff[3] = 'X' /* параметр команды  X - взято из примера */

    /* Передаем запрос */
    rssend(Buff, 4, port)
    /* Читаем ответ */
    Len = rsrecv(Buff, 16, 100, 100, port)
    printf("BT008 read len = %d", Len);
    if (Len >= 4)    
    {
        v = (Buff[3] << 24) + (Buff[2] << 16) + (Buff[1] << 8) + (Buff[0] << 0);
        Value = Hex2Float(v);
        Weight = floatround((Value * 1000), floatround_floor);
        Pow = 3;
        return true;
    }
    return false;
}