/* ИНДИКАТОРЫ ВЕСОИЗМЕРИТЕЛЬНЫЕ МИ ВДА/7Я и МИ ВЖА/7Я
 * Схема подключения RS232 указана на стр 9 РЭ на весы.
 * Скорость передачи 1200, 2400, 4800, 9600 8 бит 1 старт бит,
 * Параметр P5 (режим передачи) должен быть установлен равным 4
 * Параметр P3 (скорость передачи)
 * Описание параметров приведено на странице 12
 * (c) Copyright 2020, GLONASSsoft
 * This file is provided as is (no warranties).
 */

#pragma library LibraMI

#include serial

/* Функция чтения данных о весе с весов */
stock bool:MiRead(SerialPort:port = SERIAL_PORT_0, &Weight)
{
  new Buff[32]
  new Len
  new Value;

  Buff[0] = 0x0A /* Получить данные о весе */

  /* Передаем запрос */
  rssend(Buff, 1, port)
  /* Читаем ответ */
  Len = rsrecv(Buff, 32, 1000, 100, port)
  printf("Read len = %d", Len);
  if ((Len < 20)  || (Buff[18] != 0x0D) || (Buff[19] != 0x0A)) /* Если ответ меньше 20 байт или последние символы не 0x0d 0x0a */
  {
    return false;
  }
  Value = (Buff[5] * 100000) + (Buff[4] * 10000) + (Buff[3] * 1000) + (Buff[2] * 100) + (Buff[1] * 10) + (Buff[0] * 1);
  Weight = Value;
  return true;
}


