/* ИНДИКАТОР ВЕСОИЗМЕРИТЕЛЬНЫЙ СКИ-12
 * Схема подключения RS232 указана на стр 6 РЭ на весы.
 * Скорость передачи 1200, 2400, 4800, 9600 8 бит 1 старт бит,
 * Параметр P5 (режим передачи) должен быть установлен равным 4
 * Параметр P3 (скорость передачи) должен соответствовать установленому на терминале
 * Описание параметров приведено на странице 12
 * (c) Copyright 2021, GLONASSsoft
 * This file is provided as is (no warranties).
 */

#pragma library LibraSKI

#include serial

#define WEIGHT_TYPE_NOT 0 // Не удалось определить
#define WEIGHT_TYPE_W   1 // (вес брутто)
#define WEIGHT_TYPE_N   2 // (вес нетто)

#define SKI_DATA[.Weight, .Pow, .TypeWeight]

/* Функция чтения данных о весе с весов */
stock bool:LibraSKIRead(SerialPort:port = SERIAL_PORT_0, Data[SKI_DATA])
{
  new Buff[16]
  new Len
  new lData[SKI_DATA] = [0, 0, WEIGHT_TYPE_NOT];
  new bool:PointFound = false;

  Buff[0] = 'R' /* Получить данные о весе */

  /* Передаем запрос */
  rssend(Buff, 1, port)
  /* Читаем ответ */
  Len = rsrecv(Buff, sizeof(Buff), 1000, 100, port)
  printf("Read len = %d", Len);
  if ((Len < 11)  || (Buff[0] != 'w')) /* Если ответ меньше 11 байт или первый символ не 'w' */
  {
    return false;
  }
  /* Разбираем данные */
  for (new i = 1; i < 9; i++)
  {
    if ('0' <= Buff[i] <= '9')
    {
        lData.Weight = (lData.Weight * 10)
        lData.Weight += (Buff[i] - '0');
        if (PointFound) lData.Pow++; 
    }
    else if (Buff[i] == 'w')
    {
        lData.TypeWeight = WEIGHT_TYPE_W;
    }
    else if (Buff[i] == 'n')
    {
        lData.TypeWeight = WEIGHT_TYPE_N;
    }    
    else if (Buff[i] == '.')
    {
        PointFound = true;
    }
  }
  Data = lData

  return true;
}
