/* Опрос весов НВТ-1Н
 * Скорость работы 9600.  Весы сами передают данные  
 * Период опроса 1000 мсек
 */


#include <tracker>
#include <args>
#include <time>
#include <string>
#include <serial>
#include LibraNVT_1N

#pragma dynamic               256

#define WEIGHT_TAG            0

#define SERIAL_PORT_LIBRA     SERIAL_PORT_1

/* Очистка приемного буфера */
static ClearRxBuffer()
{
    new sb[32];   
    while (rsrecv(sb) != 0){}
}
/* Скрипт */
main()
{
  new bool:Valid = false
  new Weight
  new WeightPow;
  new Buff[32];
  new Len
  new ParseBack = 0;
  
  argvalue(0, "Back", ParseBack);   // Читаем настройку распарсивания  
  printf("ParseBack=%d", ParseBack); // Выводим 

  for(;;)
  {
    /* Читаем весы */
    Valid = false;
    if (rsopen(SB_AUTO, SERIAL_PORT_LIBRA) == true) /* Удалось открыть порт */
    {
        ClearRxBuffer();
        Len = NVT_1N_Read(SERIAL_PORT_LIBRA, Buff, sizeof(Buff));
        if (!ParseBack)
        {
            Valid = NVT_1N_Parse_Direct(Buff, Len, Weight, WeightPow);
        }
        else
        {
            Valid = NVT_1N_Parse_Back(Buff, Len, Weight, WeightPow);
        }
        rsclose(SERIAL_PORT_LIBRA) /* Освобождаем порт  */
    }
    /* Запоминаем значения */
    settag(WEIGHT_TAG, Weight, Valid, WeightPow) /* Пишем вес в таг */
    /* пауза */
    delay(1000);
  }
}